<?php
Class Factibilidad extends Controller
{
    function __construct()
    {
        $this->className='factibilidad';
        parent::__construct();
    }

//VISTA
    public function visual($parms=null)
    {
        if(ShouldShowPage(IDPAG_CLIENTES_VER))
        {
            $this->view->mostrar('factibilidad/visual');
        }
        else
        {
            return $this->error->error_403();
        }
    }
//FIN VISTA

//CRUD
    /**
     * altaDatosTroncal()
     * @param null
     * @access public
     * @request POST: jsonCoordenadas_, JsonCoordenadasBotella_, nombreTroncal_, cantidadDePelos_, modeloFibra_, colorDeFibra_, colorBuffer_, tipoDeFibra_
     * Explicacion:
     *  Crea la troncal.
     * @return $this->error->error_403() en caso de error, sino imprime un json con los datos.
    */
    public function altaDatosTroncal()
    {
        if(ShouldShowPage(IDPAG_LOGUEADOS))
        {
            $coordenadas=getIfSetMVC('jsonCoordenadas_');
            $coordenadasBotella=getIfSetMVC('JsonCoordenadasBotella_');
            $nombreTroncal=getIfSetMVC('nombreTroncal_');
            $cantidadDePelos=getIfSetMVC('cantidadDePelos_');
            $modeloFibra=getIfSetMVC('modeloFibra_');
            $colorPeloFibra=getIfSetMVC('colorDeFibra_');
            $colorBuffer=getIfSetMVC('colorBuffer_');
            $tipoDeFibra=getIfSetMVC('tipoDeFibra_');

            $this->factibilidadModel->altaCoordenadasTroncal($colorPeloFibra,$tipoDeFibra,$nombreTroncal,$cantidadDePelos,$latitud,$longitud,$coordenadas);
        }
        else
        {
            return $this->error->error_403();
        }
    }

    /**
     * agregarBotella()
     * @param null
     * @access public
     * @request -
     * Explicacion:
     *  Agrego la botella al grafico, a traves del metodo agregoBotella() del modelo factibilidadModel y le paso por parametros las coordenadas de la botella.
     * @return $this->error->error_403() en caso de error, sino imprime un json con los datos.
    */
    public function agregarBotella()
    {
        if(ShouldShowPage(IDPAG_LOGUEADOS))
        {
            $coordenadasBotella=getIfSetMVC('JsonCoordenadasBotella_');
            $res=$this->globalModel->insertar($this->tablaPrincipal,$coordenadasBotella);
            echo json_encode($res);
        }
        else
        {
            return $this->error->error_403();
        }
    }

    //SUBTRONCAL
    /**
     * altaDatosSubTroncal()
     * @param null
     * @access public
     * @request POST: jsonCoordenadasSubTroncal_
     * Explicacion:
     *  Elimina todas las botellas, a traves del metodo agregoSubTroncal() del modelo factibilidadModel, se asigna por parametro las coordenadas de la subtroncal
     * @return $this->error->error_403() en caso de error, sino imprime un json con los datos.
    */
    public function altaDatosSubTroncal()
    {
        if(ShouldShowPage(IDPAG_LOGUEADOS))
        {
            $coordenadasSubTroncal=getIfSetMVC('jsonCoordenadasSubTroncal_');
            $res=$this->globalModel->insertar($this->tablaPrincipal,$coordenadasSubTroncal);
            echo json_encode($res);
        }
        else
        {
            return $this->error->error_403();
        }
    }

    /**
     * eliminarTroncal()
     * @param null
     * @access public
     * @request -
     * Explicacion:
     *  Elimina la troncal, a traves del metodo eliminarCoordenadasTroncal() del modelo factibilidadModel
     * @return $this->error->error_403() en caso de error, sino imprime un json con los datos.
    */
    public function eliminarTroncal()
    {
        if(ShouldShowPage(IDPAG_LOGUEADOS))
        {
            $this->factibilidadModel->eliminarCoordenadasTroncal();
        }
        else
        {
            return $this->error->error_403();
        }
    }

    /**
     * modificarTroncalPrincipal()
     * @param null
     * @access public
     * @request POST: jsonCoordenadasTroncalModificadas_
     * Explicacion:
     *  Modifica la troncal principal
     * @return $this->error->error_403() en caso de error, sino imprime un json con los datos.
    */
    public function modificarTroncalPrincipal()
    {
        if(ShouldShowPage(IDPAG_LOGUEADOS))
        {
            $coordenasModificadasTroncal=getIfSetMVC('jsonCoordenadasTroncalModificadas_');
            $this->globalModel->modificar($this->tablaPrincipal,$coordenasModificadasTroncal,$id);
        }
        else
        {
            return $this->error->error_403();
        }
    }
//FIN CRUD

//METODOS GENERALES
    /**
     * colorFibra()
     * @param null
     * @access public
     * @request -
     * Explicacion:
     *  Obtiene el color del pelo de fibra, a traves del metodo obtenerColorPeloFibra() del modelo factibilidadModel
     * @return $this->error->error_403() en caso de error, sino imprime un json con los datos.
    */
    public function colorFibra()
    {
        if(ShouldShowPage(IDPAG_LOGUEADOS))
        {
            echo json_encode($this->globalModel->getAll('colorPeloFibra'));
        }
        else
        {
            return $this->error->error_403();
        }
    }

    /**
     * colorBuffer()
     * @param null
     * @access public
     * @request -
     * Explicacion:
     *  Obtiene el color del buffer
     * @return $this->error->error_403() en caso de error, sino imprime un json con los datos.
    */
    public function colorBuffer()
    {
        if(ShouldShowPage(IDPAG_LOGUEADOS))
        {
            echo json_encode($this->globalModel->getAll('colorBufferFibra'));
        }
        else
        {
            return $this->error->error_403();
        }
    }

    /**
     * datosTroncal()
     * @param null
     * @access public
     * @request -
     * Explicacion:
     *  Obtiene datos de la troncal, a traves del metodo obtenerDatosTroncal() del modelo factibilidadModel
     * @return $this->error->error_403() en caso de error, sino imprime un json con los datos.
    */
    public function datosTroncal()//Obtiene los datos de las coordenadas del troncal
    {
        if(ShouldShowPage(IDPAG_LOGUEADOS))
        {
            $this->globalModel->getAll('t_fibra')
            echo json_encode($this->factibilidadModel->obtenerDatosTroncal());
        }
        else
        {
            return $this->error->error_403();
        }
    }

    /**
     * eliminarTodasLasBotellas()
     * @param null
     * @access public
     * @request -
     * Explicacion:
     *  Elimina todas las botellas, a traves del metodo eliminarTodasBotellas() del modelo factibilidadModel.
     * @return $this->error->error_403() en caso de error, sino imprime un json con los datos.
    */
    public function eliminarTodasLasBotellas()
    {
        if(ShouldShowPage(IDPAG_LOGUEADOS))
        {
            echo json_encode($this->factibilidadModel->eliminarTodasBotellas());
        }
        else
        {
            return $this->error->error_403();
        }
    }

    /**
     * listarBotellas()
     * @param null
     * @access public
     * @request -
     * Explicacion:
     *  Obtiene las coordenadas de la botella
     * @return $this->error->error_403() en caso de error
    */
    public function listarBotellas()
    {
        if(ShouldShowPage(IDPAG_LOGUEADOS))
        {
            $datos = $this->factibilidadModel->obtenerBotellas();

            foreach ($datos as $dato)
            {
                echo $dato->BOTELLACOOR;
            }
        }
        else
        {
            return $this->error->error_403();
        }
    }

    /**
     * obteniendoDatosSubtroncal()
     * @param null
     * @access public
     * @request POST: -
     * Explicacion:
     *  Obtiene las coordenadas de la subtroncal
     * @return $this->error->error_403() en caso de error, sino imprime un json con los datos.
    */
    public function obteniendoDatosSubtroncal()
    {
        if(ShouldShowPage(IDPAG_LOGUEADOS))
        {
            echo json_encode($this->globalModel->getAll('factibilidad'));
        }
        else
        {
            return $this->error->error_403();
        }
    }

    /**
     * tipoDeFibra()
     * @param null
     * @access public
     * @request -
     * Explicacion:
     *  Obtiene el color del buffer, a traves del metodo obtenerTipoDeFibra() del modelo factibilidadModel
     * @return $this->error->error_403() en caso de error, sino imprime un json con los datos.
    */
    public function tipoDeFibra()
    {
        if(ShouldShowPage(IDPAG_LOGUEADOS))
        {
            echo json_encode($this->globalModel->getAll('t_fibra'));
        }
        else
        {
            return $this->error->error_403();
        }
    }
//FIN METODOS

//VALIDACION
//FIN VALIDACION

//API
//FIN API

}//Class
